﻿<#
For Copilot, to detect if the 'turn on preview features for Windows Update" is enabled
Niall brady 2023/10/04
version 0.1 initial release 2023/10/04
#>
$RegistryPath = "HKLM:\SOFTWARE\Microsoft\WindowsUpdate\UX\Settings"
$RegistryValue = Test-Path $RegistryPath
$isoptedIn = $null
$LogsFolder = "C:\ProgramData\IntuneRemediations\Copilot\"
$Logfile = $LogsFolder + "Copilot_IsContinuousInnovationOptedIn_Detection.log"
$script = "Copilot_IsContinuousInnovationOptedIn_Detection.ps1"
$version = "0.1"

Function LogWrite{
	Param ([string]$logstring)
	$a = Get-Date
	$logstring = $a,$logstring
	Try{   
		Add-content $Logfile -value $logstring -ErrorAction silentlycontinue
	}Catch{
		write-host $logstring
        $logstring="Invalid data encountered"
		Add-content $Logfile -value $logstring
	}
	write-host $logstring
}

Function CreateLogsDir{
    
If(!(test-path '$LogsFolder')){
write-host "logsfolder '$LogsFolder' doesn't seem to exist, creating it..."
 New-Item -ItemType Directory -Force -Path $LogsFolder
 write-host "succeeded creating '$LogsFolder'"
}
}

CreateLogsDir

LogWrite "Starting script: '$script' version: '$version'"
LogWrite "checking if 'HKLM:\SOFTWARE\Microsoft\WindowsUpdate\UX\Settings\IsContinuousInnovationOptedIn' value exists"

$isoptedIn = Get-ItemProperty -Path $RegistryPath | Select-Object -ExpandProperty IsContinuousInnovationOptedIn -ErrorAction SilentlyContinue
if ($isoptedIn)
        {
        LogWrite $isoptedIn
        LogWrite "Reg value already Exists. No Action Required, exiting remediation script with exit code 0."
        Exit 0
}
Else{
        LogWrite "Reg value does not exist, exiting remediation script with exit code 1."
        Exit 1    
}