﻿<#
For Copilot, to turn on the 'preview features for Windows Update"
Niall brady 2023/10/04
#>
$RegistryPath = "HKLM:\Software\Microsoft\WindowsUpdate\UX\Settings"
$RegistryValue = Test-Path $RegistryPath
$RegistryValue
$LogsFolder = "C:\ProgramData\IntuneRemediations\Copilot\"
$Logfile = $LogsFolder + "Copilot_IsContinuousInnovationOptedIn_Remediation.log"
$script = "Copilot_IsContinuousInnovationOptedIn_Remediation.ps1"
$version = "0.1"

Function LogWrite{
	Param ([string]$logstring)
	$a = Get-Date
	$logstring = $a,$logstring
	Try{   
		Add-content $Logfile -value $logstring -ErrorAction silentlycontinue
	}Catch{
		write-host $logstring
        $logstring="Invalid data encountered"
		Add-content $Logfile -value $logstring
	}
	write-host $logstring
}

Function CreateLogsDir{
    
If(!(test-path '$LogsFolder')){
write-host "logsfolder '$LogsFolder' doesn't seem to exist, creating it..."
 New-Item -ItemType Directory -Force -Path $LogsFolder
 write-host "succeeded creating '$LogsFolder'"
}
}

CreateLogsDir

LogWrite "Starting script: '$script' version: '$version'"



if(!$RegistryValue){
     try{
        LogWrite "Creating registry key"
        New-Item -Path HKLM:\Software\Microsoft\WindowsUpdate\UX\ -Name Settings –Force | Out-Null
        # create the value also...
        New-ItemProperty -Path $RegistryPath -Name 'IsContinuousInnovationOptedIn' -Value 1 -PropertyType DWord -Force | Out-Null
        Exit 0
     }
     Catch {
            LogWrite "Error creating registry key, the error was: $_"
            #Write-error $_
            Exit 1
      }
}
Else{
        LogWrite "The WindowsUpdate\UX\Settings registry key exists. Creating the required reg value now..."
        New-ItemProperty -Path $RegistryPath -Name 'IsContinuousInnovationOptedIn' -Value 1 -PropertyType DWord -Force | Out-Null
        Exit 0
    
}